addEventListener("activate", async event => {
  await registration.navigationPreload.enable();
  await clients.claim();
});

addEventListener("fetch", async event => {
  if (!event.request.url.startsWith("http://localhost:8000/redirect"))
    return;

  empty_response = new Response(null, { status: 204 });
  event.respondWith(new Promise(resolve =>
      setTimeout(() => resolve(empty_response), 1000)));

  windows = await clients.matchAll();

  response = await event.preloadResponse;
  reader = response.body.getReader();
  decoder = new TextDecoder();

  function print({done, value}) {
    text = decoder.decode(value);
    windows.map(window => window.postMessage(text));
    reader.read().then(print);
  }
  print({});
});
